// (C) Copyright 2008 Donald A. Graft, All Rights Reserved

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <assert.h>

#define BUFFER_SIZE 8000000

unsigned char Buffer[BUFFER_SIZE];
unsigned char *Rdptr;
unsigned int Read;
FILE *bits;
int IsFirstByteStreamNALU;

void InitializeBuffer(void)
{
	Read = (unsigned int) fread(Buffer, 1, BUFFER_SIZE, bits);
	Rdptr = Buffer;
}

static _inline int GetByte(unsigned char *v)
{
	unsigned int t;

	t = (unsigned int)(Rdptr - Buffer);
	if (t < Read)
	{
		*v = *Rdptr++;
		return 0;
	}
	if (t >= BUFFER_SIZE)
	{
		Read = (unsigned int)fread(Buffer, 1, BUFFER_SIZE, bits);
		if (Read == 0)
			return -1;
		Rdptr = Buffer;
		*v = *Rdptr++;
		return 0;
	}
	return -1;
}

int GetAnnexbNALU(unsigned int *nalu_len, unsigned char *nalu_buf)
{
  int pos = 0, rewind;
  int TrailingZero8Bits = 0;
  static int HadEOF;

  if (IsFirstByteStreamNALU)
  {
    // For the first NALU, skip any crap that may be at the start of the file,
    // and locate the first start code.
    while(1)
    {
		if (pos >= BUFFER_SIZE - 1)
		{
			return -1;
		}
        if (GetByte(&nalu_buf[pos++]) == -1)
			return -1;
        if (pos >= 3 && nalu_buf[pos-3] == 0 && nalu_buf[pos-2] == 0 && nalu_buf[pos-1] == 1)
            break;
		HadEOF = 0;
    }
    pos = 0;
  }
  else if (HadEOF)
	  return -1;

  nalu_buf[0] = 0;
  nalu_buf[1] = 0;
  nalu_buf[2] = 1;
  pos = 3;
  IsFirstByteStreamNALU=0;

  while (1)
  {
    if (GetByte(&nalu_buf[pos]) == -1)
    {
      *nalu_len = pos;
	  HadEOF = 1;
      return 0;
    }
	pos++;
    if (nalu_buf[pos-3] == 0 && nalu_buf[pos-2] == 0 && nalu_buf[pos-1] == 1)
		break;
  }

  if (nalu_buf[pos-4] == 0)
  {
	  rewind = 4;
      while(nalu_buf[pos-5-TrailingZero8Bits] == 0)
        TrailingZero8Bits++;
  }
  else
	  rewind = 3;

//  *nalu_len = pos - rewind - TrailingZero8Bits;
  *nalu_len = pos - 3;

  return 0;
}
